library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity CNT12 is
  port (
    CLK, RST_X, EN : in  std_logic;
    Q              : out std_logic_vector(3 downto 0) 
  );
end CNT12;

architecture RTL of CNT12 is
  signal Q_REF : std_logic_vector(3 downto 0);

begin
  Q <= Q_REF;
  
  process (CLK, RST_X) begin
    if (RST_X = '0') then
      Q_REF<= "0001";
    elsif (CLK'event and CLK = '1') then
      if (EN = '1') then
        if (Q_REF = "1100") then
          Q_REF <= "0001";
        else
          Q_REF <= Q_REF + 1;
        end if;
      end if;
    end if;
  end process;

end RTL;
