--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity FULLADD is
  port (
    A, B, CIN : in  std_logic;
    Q, COUT   : out std_logic 
  );
end FULLADD;

architecture RTL of FULLADD is

begin
  Q    <= A xor B xor CIN;
  COUT <= (A and B) or (B and CIN) or (CIN and A);

end RTL;
