--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity LED7DEC is
  port (
    KIN : in  std_logic_vector(3 downto 0);
    LED : out std_logic_vector(6 downto 0) 
  );
end LED7DEC;

architecture RTL of LED7DEC is

begin

  process (KIN)begin
    case (KIN) is
      when X"0"   => LED <= "1111110";
      when X"1"   => LED <= "0110000";
      when X"2"   => LED <= "1101101";
      when X"3"   => LED <= "1111001";
      when X"4"   => LED <= "0110011";
      when X"5"   => LED <= "1011011";
      when X"6"   => LED <= "1011111";
      when X"7"   => LED <= "1110010";
      when X"8"   => LED <= "1111111";
      when X"9"   => LED <= "1111011";
      when X"F"   => LED <= "0000000";
      when others => LED <= "1001111";
    end case;
  end process;

end RTL;
