--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
--library STD;
use STD.env.all;

entity ADDER_TB is
end ADDER_TB;

architecture SIM of ADDER_TB is
  -- 
  component ADDER
    port(A, B: in  std_logic_vector(3 downto 0);
         Q   : out std_logic_vector(3 downto 0));
  end component;

  -- 
  signal AIN, BIN: std_logic_vector(3 downto 0);
  signal QOUT    : std_logic_vector(3 downto 0);
  
begin
  -- 
  U0: ADDER port map ( A=>AIN, B=>BIN, Q=>QOUT );

  process begin  -- 
    AIN <= "0001"; BIN <= "0010"; wait for 1000 ns;
    AIN <= "0101"; BIN <= "1010"; wait for 1000 ns;
    AIN <= "0111"; BIN <= "0110"; wait for 1000 ns;
    AIN <= "0001"; BIN <= "1111"; wait for 1000 ns;
    AIN <= "1111"; BIN <= "1111"; wait for 1000 ns;
    std.env.finish(1);
--    wait;
  end process;

end SIM;
--
configuration CFG_ADDER_TB of ADDER_TB is
  for SIM
  end for;
end CFG_ADDER_TB;
