--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity COUNTER is
  port (
    CLK, RST_X : in  std_logic;
    Q          : out std_logic_vector(3 downto 0) 
  );
end COUNTER;

architecture RTL of COUNTER is

signal Q_REF : std_logic_vector(3 downto 0);

begin
  Q <= Q_REF;
  
  process (CLK, RST_X) begin
    if (RST_X = '0') then
      Q_REF <= "0000";
    elsif (CLK'event and CLK='1') then
      Q_REF <= Q_REF + 1;
    end if;
  end process;

end RTL;
